"
 COPYRIGHT (c) 1997 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libjava' }"

JavaRef subclass:#JavaField
	instanceVariableNames:'accessFlags index name signature constantValue annotations
		constantPool'
	classVariableNames:'A_FINAL A_PRIVATE A_PROTECTED A_PUBLIC A_STATIC A_TRANSIENT
		A_VOLATILE A_SMALLTALK A_SYBTHETIC A_ENUM FieldTypeClasses'
	poolDictionaries:''
	category:'Languages-Java-Reader-Support'
!

!JavaField class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


! !

!JavaField class methodsFor:'class initialization'!

initialize
    A_PUBLIC    := 16r0001. "/ JavaClass A_PUBLIC
    A_PRIVATE   := 16r0002.
    A_PROTECTED := 16r0004.
    A_STATIC    := 16r0008.
    A_FINAL     := 16r0010. "/ JavaClass A_FINAL
    A_VOLATILE  := 16r0040.
    A_TRANSIENT := 16r0080.
    A_SYBTHETIC := 16r1000.
    A_ENUM      := 16r4000.

    FieldTypeClasses := IdentityDictionary new
        "Base types"
        "/WARNING: If you change something here, you MUST also
        "/         change JavaDescriptor class>>#initialize !!!!!!

        at: #B  put: Byte;
        at: #C  put: Character;
        at: #D  put: Float;
        at: #F  put: ShortFloat;
        at: #I  put: Integer;       "Kludge: instances of java int are in fact SmallIntegers"
        at: #J  put: LargeInteger;
        at: #S  put: Short;
        at: #Z  put: Boolean;

        "Array types"
        "/WARNING: If you change something here, you MUST also
        "/         change JavaDescriptor class>>#initialize !!!!!!
        at: #'[B'  put: ByteArray;
        at: #'[C'  put: Unicode32String;
        at: #'[D'  put: DoubleArray;
        at: #'[F'  put: FloatArray;
        at: #'[I'  put: SignedIntegerArray;       "Kludge: instances of java int are in fact SmallIntegers"
        at: #'[J'  put: SignedLongIntegerArray;
        at: #'[S'  put: WordArray;
        at: #'[Z'  put: BooleanArray;

        yourself
        

        

    "
     self initialize
    "

    "Modified: / 13-05-1998 / 14:44:43 / cg"
    "Modified: / 20-07-2011 / 10:42:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaField class methodsFor:'constants'!

A_FINAL
    ^ A_FINAL


!

A_PRIVATE
    ^ A_PRIVATE


!

A_PROTECTED
    ^ A_PROTECTED

    "Created: / 13.5.1998 / 13:03:51 / cg"
!

A_PUBLIC
    ^ A_PUBLIC


!

A_STATIC
    ^ A_STATIC

    "Created: / 13.5.1998 / 13:03:55 / cg"
!

A_TRANSIENT
    ^ A_TRANSIENT


!

A_VOLATILE
    ^ A_VOLATILE


! !

!JavaField methodsFor:'accessing'!

accessFlags
    ^ accessFlags
!

annotations
    ^ annotations
!

annotations:something
    annotations := something.
!

constantPool
^ constantPool.

    "Created: / 17-12-2010 / 18:40:23 / Marcel Hlopko <hlopik@gmail.com>"
!

constantPool:something
constantPool := something.

    "Created: / 17-12-2010 / 18:41:59 / Marcel Hlopko <hlopik@gmail.com>"
!

constantValue
    ^ constantValue
!

constantValue:aValue
    constantValue := aValue
!

ensureHasAnnotations
    annotations ifNil: [ annotations := JavaAnnotationContainer for:self ].
    ^ annotations

    "Created: / 25-02-2011 / 16:04:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 16-03-2011 / 17:13:59 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

index
    ^ index
!

name
    ^ name
!

signature
    ^ signature

    "Created: / 15.10.1998 / 10:37:06 / cg"
! !

!JavaField methodsFor:'printing & storing'!

printOn: aStream

    super printOn: aStream.
    aStream 
        nextPutAll:'(name: ';
        nextPutAll: name;
        nextPut:$,; space;
        nextPutAll:'descriptor: ';
        nextPutAll: signature;
        nextPut:$)

    "Created: / 22-05-2011 / 16:07:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaField methodsFor:'private accessing'!

setAccessFlags:flags
    accessFlags := flags.

    "Created: 16.4.1996 / 13:04:25 / cg"
!

setClass:aClass
    
    class := aClass.

    "Created: / 22-11-2010 / 17:12:53 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setConstantValue:something
    constantValue := something.

    "Created: 16.4.1996 / 13:04:58 / cg"
!

setIndex:anInteger
    index := anInteger.

    "Created: / 22-11-2010 / 17:13:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

setName:aString
    name := aString.

    "Created: 16.4.1996 / 13:04:35 / cg"
!

setSignature:aString
    signature := aString.

    "Created: 16.4.1996 / 13:04:43 / cg"
! !

!JavaField methodsFor:'queries'!

initialValue
    ^ JavaClass initialValueFromSignature:signature


!

isFinal
    ^ (accessFlags bitAnd:A_FINAL) ~~ 0

    "Modified: / 13.5.1998 / 12:59:26 / cg"
!

isPrivate
    ^ (accessFlags bitAnd:A_PRIVATE) ~~ 0

    "Modified: / 13.5.1998 / 12:59:30 / cg"
!

isProtected
    ^ (accessFlags bitAnd:A_PROTECTED) ~~ 0

    "Modified: / 13.5.1998 / 12:59:35 / cg"
!

isPublic
    ^ (accessFlags bitAnd:A_PUBLIC) ~~ 0

    "Modified: / 13.5.1998 / 12:59:40 / cg"
!

isStatic
    ^ (accessFlags bitAnd:A_STATIC) ~~ 0

    "Modified: / 13.5.1998 / 12:59:43 / cg"
!

isTransient
    ^ (accessFlags bitAnd:A_TRANSIENT) ~~ 0

    "Modified: / 13.5.1998 / 12:59:51 / cg"
!

isVolatile
    ^ (accessFlags bitAnd:A_VOLATILE) ~~ 0

    "Modified: / 13.5.1998 / 12:59:56 / cg"
!

type
    ^ JavaMethod typeFromSignature:signature in:nil

    "Modified: / 8.1.1998 / 19:13:22 / cg"
!

typeClass

    ^(JavaDescriptor fromString: signature) javaClass.

    "Created: / 23-11-2010 / 17:02:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 25-11-2010 / 18:35:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaField class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaField.st,v 1.17 2009/10/09 14:04:34 cg Exp $'
!

version_CVS
    ^ 'Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaField.st,v 1.17 2009/10/09 14:04:34 cg Exp '
!

version_SVN
    ^ '$Id$'
! !

JavaField initialize!
