"{ Package: 'stx:libjava' }"

JavaClassContentRef2 subclass:#JavaFieldRef2
	instanceVariableNames:'offset type'
	classVariableNames:'T_LONG T_DOUBLE'
	poolDictionaries:''
	category:'Languages-Java-Reader-Support-new'
!


!JavaFieldRef2 class methodsFor:'initialization'!

initialize
    T_LONG := 1.
    T_DOUBLE := 2.

    "Created: / 15-05-2011 / 22:31:19 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaFieldRef2 methodsFor:'accessing'!

isJavaFieldRef
^true.

    "Created: / 11-04-2011 / 21:47:51 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

offset
    ^ offset.

    "Created: / 15-05-2011 / 22:26:08 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

type
    type == T_LONG ifTrue: [ ^ #long. ].
    type == T_DOUBLE ifTrue: [ ^ #double ].
    ^ type.

    "Created: / 15-05-2011 / 22:29:05 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaFieldRef2 methodsFor:'private - resolving'!

findResolvedStaticValue
    valueCache := JavaResolver uniqueInstance 
                resolveStaticFieldIndentifiedByRef: self.
    "/Use javaClass of the field, not the class ref!!
    classCache := valueCache javaClass. 
    classCache ifNil: [ self breakPoint: #mh ].
    self resolveStaticOffset.
    nameAndTypeCache := (constantPool at: nameAndTypeIndex) resolve.
    self resolveType.
    nameAndTypeCache ifNil: [ self breakPoint: #mh ].

    "Created: / 28-04-2011 / 22:05:10 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 18-05-2011 / 12:44:13 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 24-05-2011 / 14:05:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

findResolvedValue
    valueCache := JavaResolver uniqueInstance 
                resolveFieldIndentifiedByRef: self.
    classCache := (constantPool at: classRefIndex) resolve.
    classCache ifNil: [ self breakPoint: #mh ].
    self resolveOffset.
    nameAndTypeCache := (constantPool at: nameAndTypeIndex) resolve.
    self resolveType.
    nameAndTypeCache ifNil: [ self breakPoint: #mh ].

    "Modified: / 18-05-2011 / 12:44:17 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

resolveOffset
    "fieldRef must be resolved before calling me"
    
    | currentClass |

    currentClass := classCache.
    
    [ offset := currentClass instVarOffsetOf: self name.
    offset isNil and: [ currentClass superclass ~= JavaObject ]. ] whileTrue: [ currentClass := currentClass superclass. ].

    "Modified: / 20-05-2011 / 20:36:17 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

resolveStaticOffset
    "fieldRef must be resolved before calling me"
    
    | currentClass |

    currentClass := classCache.
    
    [ offset := currentClass class instVarOffsetOf: self name.
    offset isNil and: [ currentClass superclass ~= JavaObject ]. ] whileTrue: [ currentClass := currentClass superclass. ].

    "Modified: / 20-05-2011 / 20:36:11 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

resolveType
    type := JavaMethod typeFromSignature:((constantPool at: nameAndTypeIndex) descriptor) in:nil.
    type == #long ifTrue:[
        type := T_LONG.
    ] ifFalse:[
        type == #double ifTrue:[
            type := T_DOUBLE
        ]
    ].

    "Created: / 15-05-2011 / 22:29:02 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaFieldRef2 class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !

JavaFieldRef2 initialize!
