"{ Package: 'stx:libjava' }"

Object subclass:#JavaTestsLoader
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests'
!


!JavaTestsLoader class methodsFor:'accessing'!

buildSuiteForLibjava

    ^self buildSuiteFrom: 
        (self loadLibjava)

    "
        JavaTestsLoader buildSuiteForLibjava
    "

    "Created: / 21-06-2011 / 17:39:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

buildSuiteForMauve

    ^self buildSuiteFrom: 
        (self loadMauve)

    "
        JavaTestsLoader buildSuiteForMauve
    "

    "Created: / 21-06-2011 / 17:40:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

buildSuiteForMauveToFix

    ^self buildSuiteFrom: 
        (self loadMauveToFix)

    "
        JavaTestsLoader buildSuiteForMauveToFix
    "

    "Created: / 21-06-2011 / 17:40:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaTestsLoader class methodsFor:'loading'!

load
    JavaTestsResource build.
    self loadIn:JavaTestsResource classpath

    "Created: / 07-05-2011 / 18:43:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

load:testdir 
    |base dirs|

    base := (UserPreferences current javaTestsDirectory asFilename / testdir) 
                pathName.
    dirs := JavaTestsResource classpath 
                select:[:each | each startsWith:base ].
    self loadIn:dirs.

    "
        JavaTestsLoader load: 'libjava'"
    "Created: / 07-05-2011 / 18:40:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaTestsLoader class methodsFor:'loading - test suites'!

loadLibjava
    |cp|

    JavaTestsResource new setUp.
    cp := JavaTestsResource classpathForLibjava.
    ^self loadIn: cp

    "Created: / 21-06-2011 / 17:35:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

loadMauve
    |cp|

    JavaTestsResource new setUp.
    cp := JavaTestsResource classpathForMauve.
    ^self loadIn: cp

    "Created: / 11-06-2011 / 16:03:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

loadMauve: pattern
    |cp|

    JavaTestsResource new setUp.
    cp := JavaTestsResource classpathForMauve.
    ^self loadIn: cp matching: pattern.

    "
        JavaTestsLoader loadMauve:'gnu.testlet.java.lang.String.*'
    "

    "Created: / 12-06-2011 / 21:56:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 20-06-2011 / 19:00:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

loadMauveToFix
    |cp|

    JavaTestsResource new setUp.
    cp := JavaTestsResource classpathForMauve.
    self 
        loadIn: cp matching:'gnu.testlet.java.lang.*';
        loadIn: cp matching:'gnu.testlet.java.lang.reflect.*';
        loadIn: cp matching:'gnu.testlet.java.util.*'.

    "
        JavaTestsLoader loadMauveToFix    
    "

    "Created: / 11-06-2011 / 16:07:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaTestsLoader class methodsFor:'private'!

buildSuiteFrom: classes

    | javaTestCases suite |

    javaTestCases := OrderedCollection new.
    suite := TestSuite new.

    classes do:
        [:jclass|
        (jclass ~~ (Java at:'stx.libjava.tests.JUnit3Tests')
            and:[jclass ~~ (Java at:'stx.libjava.tests.JUnit4Tests')
                and:[jclass isTestCaseLike]])
                    ifTrue:
                        [ | tc |
                        tc := jclass asTestCase.
                                                (tc askFor:#isTestlet) ifTrue:[
                                                        tc shouldFork: true.
                                                ].
                        tc isAbstract ifFalse:[javaTestCases add:tc ]]].

    javaTestCases do:
                [:each | 
                suite addTests:each buildSuite tests ].

    ^suite

    "Modified: / 21-06-2011 / 17:39:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

loadIn: directories

    ^self loadIn: directories matching: '*'

    "Created: / 11-06-2011 / 16:05:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

loadIn: directories matching: pattern

    | classes |
    
    JavaInitializedResource new setUp.  
    JavaLibrariesResource new setUp.
    JavaTestsResource new setUp.
    classes := OrderedCollection new.

    directories do:
            [:each|
            each asFilename exists ifTrue:
                [classes addAll: (JavaClassReader loadClassesIn: each matching: pattern)]].

    ^classes

    "Created: / 11-06-2011 / 16:05:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 20-06-2011 / 19:02:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaTestsLoader class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
